<?php
//宝塔Linux面板插件demo for PHP
//@author 阿良<287962566@qq.com>

//必需面向对象编程，类名必需为bt_main
//允许面板访问的方法必需是public方法
//通过_get函数获取get参数,通过_post函数获取post参数
//可在public方法中直接return来返回数据到前端，也可以任意地方使用echo输出数据后exit();
//可在./php_version.json中指定兼容的PHP版本，如：["56","71","72","73"]，没有./php_version.json文件时则默认兼容所有PHP版本，面板将选择 已安装的最新版本执行插件
//允许使用模板，请在./templates目录中放入对应方法名的模板，如：test.html，请参考插件开发文档中的【使用模板】章节
//支持直接响应静态文件，请在./static目录中放入静态文件，请参考插件开发文档中的【插件静态文件】章节
class bt_main{
	//不允许被面板访问的方法请不要设置为公有方法

	public function test() {
		//_post()会返回所有POST参数，要获取POST参数中的username参数，请使用 _post('username')
		//可通过_version()函数获取面板版本
		//可通过_post('client_ip') 来获取访客IP

		//常量说明：
		//PLU_PATH 插件所在目录
		//PLU_NAME 插件名称
		//PLU_FUN  当前被访问的方法名称
		return array(
			_get(),
			_post(),
			_version(),
			PLU_FUN,
			PLU_NAME,
			PLU_PATH
		);
	}
	// 读取API列表
	public function index() {
		$api = fopen("/www/server/panel/plugin/baidu_push/api.ini", "r") or die("Unable to open file!");
		$apis = fread($api,filesize("/www/server/panel/plugin/baidu_push/api.ini"));
		exit(json_encode(array('code' => 0, 'msg' => '', 'data' => $apis)));
	}
	
	// API列表
	public function api() {
		$txt = trim(_post('apis'));
		$api = fopen("/www/server/panel/plugin/baidu_push/api.ini", "w");
		fwrite($api, $txt);
		fclose($api);
		exit(json_encode(array('code' => 0, 'msg' => 'API保存成功')));
	}

	// 百度推送
	public function baidu_push() {
		$api = trim(_post('api'));
		$urls = trim(_post('urls'));
		if (empty($api)) {
			exit(json_encode(['code' => 1, 'msg' => 'API接口不能为空']));
		}
		if (empty($urls)) {
			exit(json_encode(['code' => 1, 'msg' => '推送链接不能为空']));
		}
		$headers = array('Content-Type: text/plain');
		$baidu = curl_init();
		curl_setopt($baidu, CURLOPT_URL, $api);
		curl_setopt($baidu, CURLOPT_POST, true);
		curl_setopt($baidu, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($baidu, CURLOPT_POSTFIELDS, $urls);
		curl_setopt($baidu, CURLOPT_HTTPHEADER, $headers);
		$baidu_result = json_decode(curl_exec($baidu), true);
		curl_close($baidu);
		exit(json_encode(array('code' => 0, 'msg' => '推送成功条数：' . $baidu_result['success'] . '条，剩余可推送url条数：' . $baidu_result['remain'] . '条！')));
	}
	
	// 百度MIP推送
	public function mip_push() {
		$api = trim(_post('api'));
		$urls = trim(_post('urls'));
		if (empty($api)) {
			exit(json_encode(['code' => 1, 'msg' => 'API接口不能为空']));
		}
		if (empty($urls)) {
			exit(json_encode(['code' => 1, 'msg' => '推送链接不能为空']));
		}
		$headers = array('Content-Type: text/plain');
		$mip = curl_init();
		curl_setopt($mip, CURLOPT_URL, $api);
		curl_setopt($mip, CURLOPT_POST, true);
		curl_setopt($mip, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($mip, CURLOPT_POSTFIELDS, $urls);
		curl_setopt($mip, CURLOPT_HTTPHEADER, $headers);
		$mip_result = json_decode(curl_exec($mip), true);
		curl_close($mip);
		exit(json_encode(array('code' => 0, 'msg' => '推送成功条数：' . $mip_result['success_mip'] . '条，剩余可推送url条数：' . $mip_result['reamin_mip'] . '条！')));
	}
	
	// 神马MIP推送
	public function shenma_push() {
		$api = trim(_post('api'));
		$urls = trim(_post('urls'));
		if (empty($api)) {
			exit(json_encode(['code' => 1, 'msg' => 'API接口不能为空']));
		}
		if (empty($urls)) {
			exit(json_encode(['code' => 1, 'msg' => '推送链接不能为空']));
		}
		$headers = array('Content-Type: text/plain');
		$shenma = curl_init();
		curl_setopt($shenma, CURLOPT_URL, $api);
		curl_setopt($shenma, CURLOPT_POST, true);
		curl_setopt($shenma, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($shenma, CURLOPT_POSTFIELDS, $urls);
		curl_setopt($shenma, CURLOPT_HTTPHEADER, $headers);
		$shenma_result = json_decode(curl_exec($shenma), true);
		curl_close($shenma);
		if($shenma_result['returnCode'] === 200) {
			exit(json_encode(array('code' => 0, 'msg' => '推送成功')));
		} else {
			exit(json_encode(array('code' => 1, 'msg' => '推送失败')));
		}
	}
}


?>